	SUBROUTINE SLMTPAR(IPAN)
*********************************************************
*  Subroutine prepares arrays depended on potential     *
*  parameters for LMTBND program                        *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	COMPLEX*16
     &    AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,HMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,HMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,HMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,HMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,OMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,FHHFH,FJHFH,FHHFJ,FJHFJ,FHFH,FHFJ,FJFH,FJFJ
	DIMENSION 
     &    DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,FF(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,FFP(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,FPF(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,FPFP(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,GAM(0:LMAXT,NSORTMAX),SMT(NSORTMAX)
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,TPAN(NSORTMAX,NKAPMAX),FIRST
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY                !!! from potpar
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /POTCOM/ SWZ,SMT                              !!! from readini
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from readini
C Pot.pars:
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ                  !!! from potpar
	COMMON /POTPAR/ FF,FFP,FPF,FPFP                      !!! from potpar
	COMMON /MTPAR/  HMTHH,HMTJH,HMTHJ,HMTJJ,OMTHH,OMTJH,OMTHJ,OMTJJ
	COMMON /INDX/   IND                                  !!! from lmtpar
C Outputs:
	COMMON /TXTEL/  TXTEL,TXTSP                          !!! from readini
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /WORD/   NVAL                                 !!! from setup
	SAVE FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C  SET COMPLEX INDEX
	IDIM=0
	DO ISPIN=1,NSPIN
	DO IKAP=1,NKAP(IPAN)
	DO IATOM=1,NATOM
	DO L=0,ILSB(IS(IATOM))
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=IDIM+1
	IND(LM,IATOM,IKAP,ISPIN,IPAN)=IDIM
	ENDDO 
	ENDIF
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
C  COMPUTE POTENTIAL PARAMETERS FOR THE OVERLAP MATRIX AND HAMILTONIAN ::
	DO 2000 ISPIN=1,NSPIN                             !!! over ispin
	DO 1000 ISORT=1,NSORT                             !!! over isort
	DO L=0,ILST(ISORT)                                !!! over l
	DO IKAP1=1,NKAP(IPAN)                             !!! over ikap1
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
C  SET POTENTIAL PARAMETERS TO ZERO
	IF(L.LE.ILSB(ISORT))THEN
	OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	ENDIF
	OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
C  ONE- AND TWO-CENTER POTENTIAL PARAMETERS
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
	FHFH=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN)   
     & +CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAH(L,ISORT,IKAP,IPAN,ISPIN)   
	OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=FHFH
	FHHFH=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     *  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=FHHFH+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	FJFH=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN)    
     & +CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAH(L,ISORT,IKAP,IPAN,ISPIN)    
	OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=FJFH*GAM(L,ISORT)
	FJHFH=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=FJHFH*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP1,IPAN))THEN
	FHFJ=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)    
     & +CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAJ(L,ISORT,IKAP,IPAN,ISPIN)
	OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=FHFJ*GAM(L,ISORT)
	FHHFJ=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=FHHFJ*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C  THREE-CENTER POTENTIAL PARAMETERS
	FJFJ=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)
     & +CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAJ(L,ISORT,IKAP,IPAN,ISPIN)    
	FJHFJ=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)
	OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=FJFJ*GAM(L,ISORT)*GAM(L,ISORT)
	HMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=FJHFJ*GAM(L,ISORT)*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
        ENDDO                                                    !!! over ikap
        ENDDO                                                    !!! over ikap1
        ENDDO                                                    !!! over l
1000    CONTINUE                                                 !!! over isort
2000	CONTINUE                                                 !!! over ispin
	END


	SUBROUTINE SPRIPAR(IPAN)
*********************************************************
*  Prints potential parameters.                         *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),NPNT(NPANMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),NHSORT(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),NDIV(3),NDIC(3)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	DIMENSION DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,CNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,WNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,SH(3,NPANMAX),HSPNT(3,2,KMAX)
        CHARACTER*60 DOSFILE,CONFILE,KOVFILE,PSIFILE,FATFILE,BNDFILE
     &    ,POTFILE,SCFFILE,OUTFILE,FTRFILE,TMPFILE,SCRFILE(100)
	CHARACTER TXTNY(0:3)*6,TL(0:3)*1,TN(9)*1,TXTSP(2)*2
     &   ,TXTEL(NSORTMAX)*10,PNTNOT(2,KMAX)*1
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,TPAN(NSORTMAX,NKAPMAX),FIRST
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NCOU,NINT,NPF              !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /ORBS/   NORBS                                !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT(NSORTMAX)                    !!! from readini
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY,DHLOG          !!! from potpar
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /KKRPAR/ CNY,WNY                              !!! from kkrpar
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from readini
        COMMON /EFERMI/ EF                                   !!! Fermi energy
	COMMON /INDX/   IND                                  !!! from lmtpar
C K-mesh:
	COMMON /MESH/   NPNT                                 !!! from bzmesh
        COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT              !!! from readstr
        COMMON /HSPNTS/ PNTNOT                               !!! from readstr
C Outputs:
	COMMON /OUT0/   SCRFILE                              !!! from readini
	COMMON /OUT1/   ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND  !!! from readini
     &                 ,ICPOT,ICFAT,ICDOS,ICSCF,ICOUT
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE,BNDFILE
     &                 ,POTFILE,FATFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /TXTEL/  TXTEL,TXTSP                          !!! from readini
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /WORD/   NVAL                                 !!! from setup
	SAVE FIRST
	DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/,TN/'1','2'
     &      ,'3','4','5','6','7','8','9'/,TXTNY/'fix.E '
     &      ,'fix.D ','bind.E','center'/,FIRST/.TRUE./
	DO IKAP=1,NKAP(IPAN)
	DO IATOM=1,NATOM
	TPAN(IS(IATOM),IKAP)=.FALSE.
	DO L=0,ILSB(IS(IATOM))
	IF(LTPAN(L,IATOM,IKAP,IPAN))TPAN(IS(IATOM),IKAP)=.TRUE.
	ENDDO
	ENDDO
	ENDDO
C   OPEN FILE FOR WAVE COEFFICIENTS
	NRECL=0
	DO ISORT=1,NSORT  !!! estimate record lenght
	MAXLM=(ILST(ISORT)+1)**2+(ILSB(ISORT)+1)**2 
	NRECL=MAX(NRECL,NVAL*MAXLM*NATOM)
	ENDDO
	IF(.NOT.FIRST)CLOSE(14,STATUS='DELETE')
	OPEN(UNIT=14,FILE=SCRFILE(14),STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
	IF(ICPSI.EQ.0.AND.IPAN.EQ.1)THEN ! storage is not necessary
	IF(.NOT.FIRST)CLOSE(15,STATUS='DELETE')
	OPEN(UNIT=15,FILE=SCRFILE(15),STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
	ELSEIF(ICPSI.EQ.1.AND.IPAN.EQ.1)THEN
	IF(.NOT.FIRST)CLOSE(15,STATUS='DELETE')
	OPEN(UNIT=15,FILE=PSIFILE,STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
C  OPEN FILE FOR TL-CHARACTERS IF NECESSARY
	NRECL=0
	DO ISORT=1,NSORT  !!! estimate record lenght
	NRECL=NRECL+NVAL*(ILST(ISORT)+1)*NKAP(1)**2
	ENDDO
	IF(ICDOS.NE.0.AND.IPAN.EQ.1)THEN
	IF(.NOT.FIRST)CLOSE(17,STATUS='DELETE')
	OPEN(UNIT=17,FILE=SCRFILE(17),STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
        ENDIF
C  OPEN FILE FOR PULAY FORCES
        NRECL=NVAL*3*NATOM*2
        IF(NPF.NE.0.AND.IPAN.EQ.1)THEN
        IF(.NOT.FIRST)CLOSE(16,STATUS='DELETE')
        OPEN(UNIT=16,FILE=SCRFILE(16),STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
C  OPEN FILE FOR TLM-CHARACTERS TO PLOT FAT BANDS
	IF(ICFAT.NE.0.AND.IPAN.EQ.1)THEN
	IF(.NOT.FIRST)CLOSE(22,STATUS='DELETE')
	OPEN(UNIT=22,FILE=FATFILE,STATUS='NEW',ACCESS='SEQUENTIAL',
     &  FORM='UNFORMATTED')
	WRITE(22)NATOM,NSORT,NSPIN,NORBS,(IS(IATOM),IATOM=1,NATOM),
     &  (ILSB(ISORT),ISORT=1,NSORT),(NHSORT(ISORT),ISORT=1,NSORT),
     &  NKAP(1),NBNDF(1),NBNDE(1),NBNDT(1),NPNT(1),NDIR,NDIV(1),EF
	WRITE(22)(TXTEL(ISORT),ISORT=1,NSORT),
     &  ((PNTNOT(INOT,IDIR),INOT=1,2),IDIR=1,NDIR)
        ENDIF
	FIRST=.FALSE.
	DO ISPIN=1,NSPIN                          !!! over ispin
	IF(NSPIN.EQ.1)WRITE(IUN,1010)NKAP(IPAN),IPAN
	IF(NSPIN.EQ.2)WRITE(IUN,1015)NKAP(IPAN),TXTSP(ISPIN),IPAN
	DO ISORT=1,NSORT                          !!! over isort
	DO IKAP=1,NKAP(IPAN)                      !!! over ikap
	IF(ISTS(ISORT,IPAN).NE.0.AND.TPAN(ISORT,IKAP))
     &  WRITE(IUN,1020)DREAL(EKAP(IKAP,IPAN)),TXTEL(ISORT)
	DO L=0,ILSB(ISORT)                        !!! over l
	MN=MNY(L,ISORT,IKAP,IPAN)
	NO=TNY(L,ISORT,IKAP,IPAN,ISPIN)+L+1
	IF(LSPAN(L,ISORT,IKAP,IPAN))
     &	WRITE(IUN,1030)ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &  DNY(L,ISORT,IKAP,IPAN,ISPIN),CNY(L,ISORT,IKAP,IPAN,ISPIN),
     &  WNY(L,ISORT,IKAP,IPAN,ISPIN),TN(NO)//TL(L),TXTNY(MN)
C	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN).AND.IPAN.EQ.1)
C    &	WRITE(IUN,1040)ENY(L,ISORT,IKAP,IPAN,ISPIN),
C    &  DNY(L,ISORT,IKAP,IPAN,ISPIN),TN(NO)//TL(L),TXTNY(MN)
	ENDDO                                     !!! over l
	ENDDO                                     !!! over ikap
	ENDDO                                     !!! over isort
	ENDDO                                     !!! over ispin
1010    FORMAT(1X,I1,'kappa panel #',I2,
     &  ' : Band Structure Calculation of E(k) with :')
1015    FORMAT(1X,I1,'kappa spin-',A2,' panel #',I2,
     &  ' : Band Structure Calculation of E(k) with :')
1020    FORMAT('     Eny:    ','     Dny:    ','     Cny:    ',
     &         '     Wny:    ',' Et=',G10.3,A11)
1030    FORMAT(4(1X,G12.5),    ' for ',A2,'-state, ',A6)
1040    FORMAT(2(1X,G12.5),26X,' for ',A2,'-state, ',A6)
	END
