	SUBROUTINE OUTPUT(TEXT)
******************************************************
*   Output module of the LMTO package                *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX),LR(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),NDIV(3)
     &    ,NPNT(NPANMAX),NDIC(3)
	DIMENSION SMT(NSORTMAX),EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &    ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,PNT(3,KMAX,NPANMAX),ORTH(2:3),SH(3,NPANMAX)
     &    ,PTS(0:LMAXT),PDS(0:LMAXT),HSPNT(3,2,KMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,ADOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,ATOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX,0:5)
	CHARACTER*60 DOSFILE,CONFILE,KOVFILE,FATFILE,PSIFILE,BNDFILE
     &    ,POTFILE,SCFFILE,OUTFILE,FTRFILE,TMPFILE,SCRFILE(100)
     &    ,PTNFILE
	CHARACTER  TXTEL(NSORTMAX)*10,TEXT*(*),EQ(64),TEXCH(0:30)*40
     &    ,TRELATIV(0:1)*4,PNTNOT(2,KMAX)*1
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),EXIST,OPEN
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/LIFT                                !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from vfull
	COMMON /RELATIV/LR                                  !!! from init
	COMMON /EFERMI/ EF                                  !!! from ttrint
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                   !!! # of bands
	COMMON /INPPAR/ TNY,ENY,DNY                         !!! from potpar
	COMMON /ENERGY/ EARR                                !!! from bands
	COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT             !!! from strmsh
	COMMON /HSPNTS/ PNTNOT                              !!! from init
	COMMON /TOSDOS/ ATOS,ADOS                           !!! from ttrint
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /LATPAR/ PAR,ORTH                            !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	COMMON /ORBS/   NORBS                               !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /EXCH/   IXC                                 !!! from init
	COMMON /OUT0/   SCRFILE                             !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV,IPSI,ITMP,IBND,IPOT,IFAT,IDOS
     &                 ,ISCF,IOUT
	COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE,BNDFILE
     &                 ,POTFILE,FATFILE,DOSFILE,SCFFILE,OUTFILE
	DATATEXCH(0)/'Not included!'/ 
     &     ,TEXCH(1)/'Barth-Hedin'/ 
     &     ,TEXCH(2)/'Gunnarson-Lundqvist'/
     &     ,TEXCH(3)/'Janak-Williams-Morruzi'/
     &     ,TEXCH(4)/'Vosko-Wilk-Nussair'/
     &     ,TEXCH(5)/'Perdew-Wang 1991'/
     &     ,TEXCH(6)/'Gaspar-Kohn-Sham'/
     &     ,TRELATIV/'Non-','Semi'/
     &     ,EQ/64*'='/
	WRITE(IUN,1000)EQ
	WRITE(IUN,*)TEXT
	IF(LIFT.EQ.1)STOP
1000    FORMAT(1X,64A)
	WRITE(IUN,1010)PAR
	WRITE(IUN,1011)ORTH
	ILR=0
	DO ISORT=1,NSORT
	IF(LR(ISORT).NE.0)ILR=1
        WRITE(IUN,1012)SMT(ISORT),ILST(ISORT),ILSB(ISORT),ILSV(ISORT),
     &  TXTEL(ISORT)
	ENDDO
        ILDA=MOD(IXC,10)     !!! LDA key
        IGGA=(IXC-ILDA)/10   !!! GGA key
	WRITE(IUN,*)'Local Exchange-Correlation : ',TEXCH(ILDA)
	IF(IGGA.EQ.1)
     &  WRITE(IUN,*)'Including gradient corrections after Perdew 91'
	IF(IGGA.EQ.2)
     &  WRITE(IUN,*)'Including gradient corrections after Perdew 96'
	WRITE(IUN,*)TRELATIV(ILR)//'relativistic Version'
	IF(NORBS.EQ.2)WRITE(IUN,*)'with spin-orbit coupling'
	IF(NSPIN.EQ.1)WRITE(IUN,*)'Non-Spin-Polarized Version'
	IF(NSPIN.EQ.2)WRITE(IUN,*)'Spin-Polarized Version'
1010    FORMAT(' Lattice Parameter  =',G14.7)
1011    FORMAT(' B/A =',G14.7,' C/A =',G14.7)
1012    FORMAT(' S   =',G14.7,' Lmax=',3(1X,I2),1X,A10)
C  ENERGY BAND STRUCTURE
	IF(IBND.EQ.1)THEN
	OPEN(3,FILE=BNDFILE,STATUS='NEW')
	WRITE(3,1021)NATOM,EF,NPNT(1),NDIV(1),NBNDT(1)*NORBS,
     &  NSPIN-NORBS+1
	DO IPNT=1,NPNT(1)
	WRITE(3,1022)(PNT(J,IPNT,1),J=1,3)
	WRITE(3,1023)((EARR(IBNDS+NSPIN*(J-1),IPNT,1),
     &  IBNDS=1,NSPIN),J=1,NBNDT(1))
	ENDDO
	CLOSE(3)
	ELSEIF(IBND.EQ.2)THEN
	OPEN(3,FILE=BNDFILE,STATUS='NEW')
	WRITE(3,1024)EF,NPNT(1),NDIV(1),NDIV(2),NDIV(3),
     &  NBNDT(1)*NORBS,NSPIN-NORBS+1
	DO IPNT=1,NPNT(1)
	WRITE(3,1022)(PNT(J,IPNT,1),J=1,3)
	WRITE(3,1023)((EARR(IBNDS+NSPIN*(J-1),IPNT,1),
     &  IBNDS=1,NSPIN),J=1,NBNDT(1))
	ENDDO
	CLOSE(3)
	ENDIF
1021    FORMAT(1X,I4,1X,G14.7,1X,I4,1X,I2,1X,I4,1X,I2)
1022    FORMAT(1X,3(1X,G14.7))
1023    FORMAT(1X,5(1X,G14.7))
1024    FORMAT(1X,G14.7,1X,I4,3(1X,I2),1X,I4,1X,I2)
C  DENSITY OF STATES
	IF(IDOS.EQ.1)THEN
	OPEN(3,FILE=DOSFILE,STATUS='OLD',FORM='FORMATTED')
	READ(3,*)EMIN,EMAX,NPNTDOS
	WRITE(3,*)NSORT,MIN(LMAXT,3),1,NSPIN,
     &  (NHSORT(ISORT),ISORT=1,NSORT)
	CALL TTRINT1(EF,TOS,DOS,1)
	CALL TTRINT4(EF,TOS,DOS,0)
	WRITE(3,1032)EF,TOS,DOS 
	DO ISPIN=1,NSPIN
	DO ISORT=1,NSORT
	DO L=0,MIN(LMAXT,3)
	PDS(L)=0.D0
	ENDDO
	DO L=0,MIN(ILST(ISORT),3)
	DO IKAP1=1,NKAP(1)
	DO IKAP=1,NKAP(1)
	PDS(L)=PDS(L)+ADOS(L,ISORT,IKAP1,IKAP,1,ISPIN)
	ENDDO
	ENDDO
	ENDDO
	WRITE(3,1033)1,ISORT,ISPIN,(PDS(L),L=0,MIN(LMAXT,3))
	ENDDO
	ENDDO
	DELTAE=(EMAX-EMIN)/NPNTDOS
	DO IPNTDOS=0,NPNTDOS
	E0=EMIN+IPNTDOS*DELTAE
	CALL TTRINT1(E0,TOS,DOS,1)
	CALL TTRINT4(E0,TOS,DOS,0)
	WRITE(3,1031)E0,TOS,DOS 
	DO ISPIN=1,NSPIN
	DO ISORT=1,NSORT
	DO L=0,MIN(LMAXT,3)
	PDS(L)=0.D0
	ENDDO
	DO L=0,MIN(ILST(ISORT),3)
	DO IKAP1=1,NKAP(1)
	DO IKAP=1,NKAP(1)
	PDS(L)=PDS(L)+ADOS(L,ISORT,IKAP1,IKAP,1,ISPIN)
	ENDDO
	ENDDO
	ENDDO
	WRITE(3,1033)1,ISORT,ISPIN,(PDS(L),L=0,MIN(LMAXT,3))
	ENDDO
	ENDDO
	ENDDO
	CLOSE(UNIT=17,STATUS='DELETE')
	CLOSE(3)
1031    FORMAT(1X,3(1X,G14.7),10X,' - E ,TOS,DOS')
1032    FORMAT(1X,3(1X,G14.7),10X,' - EF,TOS,DOS')
1033    FORMAT(1X,I2,1X,I2,1X,I2,1X,4(1X,G12.5))
	ENDIF
	IF(ISCF.EQ.0)
     &  OPEN(3,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	IF(ISCF.EQ.0)CLOSE(UNIT=3  ,STATUS='DELETE')  !!! charge density
	IF(IOUT.EQ.0)CLOSE(UNIT=IUN,STATUS='DELETE')  !!! output channel 
	DO I=1,99
	INQUIRE(FILE=SCRFILE(I),EXIST=EXIST,OPENED=OPEN)
	IF(EXIST)THEN
	IF(.NOT.OPEN)OPEN(UNIT=I,FILE=SCRFILE(I),FORM='UNFORMATTED',
     &  STATUS='OLD')
	NA=INDEX(SCRFILE(I),' ')
	CLOSE(UNIT=I,STATUS='DELETE')
	PRINT*,SCRFILE(I)(:NA-1)//' DELETED !'
	ENDIF
	ENDDO
	STOP
	END
