	SUBROUTINE SPOTPAR(IPAN)
****************************************************************
*  Subroutine prepares potential parameters for LMTPAR program *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NHSORT(NSORTMAX),IS(NPAT),NRAD(NSORTMAX),LR(NSORTMAX)
     &    ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NKAP(NPANMAX)
	COMPLEX*16 HAN(3,0:LMAXT),BES(3,0:LMAXT)
     &    ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,HS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,BS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,ALPHA(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,ALPDOT(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,DLOG(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
	DIMENSION DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,GAM(0:LMAXT,NSORTMAX),FPMN(0:LMAXT)
     &    ,AFIS(0:LMAXT,NKAPMAX),DNYP(0:LMAXT,NKAPMAX)
     &    ,FF(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,FFP(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,FPF(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,FPFP(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,AFIPS(0:LMAXT,NKAPMAX),SMT(NSORTMAX)
     &    ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),H(NSORTMAX)
     &    ,POTS(0:NRADMAX),RLOC(NSORTMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
C Inputs:
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY,DHLOG          !!! from seteny
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
	COMMON /LATPAR/ PAR                                  !!! from readini
C Pot.pars:
	COMMON /POTPAR/ FF,FFP,FPF,FPFP                      !!! from potpar
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ                  !!! from potpar
	COMMON /ASAPAR/ HS,BS,DH,DJ                          !!! from potpar
C Screening constants:
        COMMON /SCRINP/ RLOC,ALPHA,ALPDOT,DLOG               !!! from alpcon
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmsh
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	DATA PI/3.141592653589793D0/
	DO ISPIN=1,NSPIN                                  !!! over spins
	DO ISORT=1,NSORT                                  !!! over isort
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
	CALL BESSEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),BES,
     &  ILST(ISORT))
	CALL HANKEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),HAN,
     &  ILST(ISORT))
C  SOLVE SCHROEDINGER'S EQUATION FOR THE ENY
        CALL RUNGE(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFIS(0,IKAP),
     &  AFIPS(0,IKAP),DNY(0,ISORT,IKAP,IPAN,ISPIN),
     &  TNY(0,ISORT,IKAP,IPAN,ISPIN),DNYP(0,IKAP),FPMN,
     &  SMT(ISORT),VSPH(0,ISORT,ISPIN),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
	DO L=0,ILST(ISORT)                      !!! over l
C  CHECK RADIAL FUNCTIONS IN CASE SEMICORE STATES
	IF(MNY(L,ISORT,IKAP,IPAN).EQ.2)THEN
	IF(ABS(DNY(L,ISORT,IKAP,IPAN,ISPIN)-
     &  DHLOG(L,ISORT,IKAP,IPAN,ISPIN)).GE.1.D-05)
     &  WRITE(IUN,1010)ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &  DNY(L,ISORT,IKAP,IPAN,ISPIN),
     &  DHLOG(L,ISORT,IKAP,IPAN,ISPIN),
     &  L,ISORT,IKAP,IPAN,ISPIN
	ENDIF
	GAM(L,ISORT)=1.D0/(SMT(ISORT)/PAR)/DFLOAT(2*L+1)
C  TRANSFORM TO SCREENED BESSEL FUNCTIONS
        BES(1,L)=BES(1,L)-ALPHA(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)*HAN(1,L)
        BES(2,L)=BES(2,L)-ALPHA(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)*HAN(2,L)
        BES(3,L)=BES(3,L)-ALPHA(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)*HAN(3,L)
C  SET MAIN POTENTIAL PARAMETERS OF THE FP-LMTO METHOD
	HS(L,ISORT,IKAP,IPAN,ISPIN)=HAN(1,L)
	BS(L,ISORT,IKAP,IPAN,ISPIN)=BES(1,L)
	DH(L,ISORT,IKAP,IPAN,ISPIN)=SMT(ISORT)*HAN(2,L)/HAN(1,L)
	DJ(L,ISORT,IKAP,IPAN,ISPIN)=SMT(ISORT)*BES(2,L)/BES(1,L)
	AAH(L,ISORT,IKAP,IPAN,ISPIN)=+SMT(ISORT)*AFIPS(L,IKAP)*
     &  HS(L,ISORT,IKAP,IPAN,ISPIN)*(DH(L,ISORT,IKAP,IPAN,ISPIN)-
     &  DNYP(L,IKAP))                                        !!! +W{Phi-dot,H}
	AAJ(L,ISORT,IKAP,IPAN,ISPIN)=+SMT(ISORT)*AFIPS(L,IKAP)*
     &  BS(L,ISORT,IKAP,IPAN,ISPIN)*(DJ(L,ISORT,IKAP,IPAN,ISPIN)-
     &  DNYP(L,IKAP))                                        !!! +W{Phi-dot,J}
	BBH(L,ISORT,IKAP,IPAN,ISPIN)=-SMT(ISORT)*AFIS (L,IKAP)*
     &  HS(L,ISORT,IKAP,IPAN,ISPIN)*(DH(L,ISORT,IKAP,IPAN,ISPIN)-
     &  DNY(L,ISORT,IKAP,IPAN,ISPIN))                        !!! -W{Phi,H}
	BBJ(L,ISORT,IKAP,IPAN,ISPIN)=-SMT(ISORT)*AFIS (L,IKAP)*
     &  BS(L,ISORT,IKAP,IPAN,ISPIN)*(DJ(L,ISORT,IKAP,IPAN,ISPIN)-
     &  DNY(L,ISORT,IKAP,IPAN,ISPIN))                        !!! -W{Phi,J}
C  SET INTEGRALS BETWEEN RADIAL WAVE FUNCTIONS
	FF(IKAP,IKAP,L,ISORT,ISPIN)=1.D0
	FFP(IKAP,IKAP,L,ISORT,ISPIN)=0.D0
	FPF(IKAP,IKAP,L,ISORT,ISPIN)=0.D0
	FPFP(IKAP,IKAP,L,ISORT,ISPIN)=FPMN(L)
	DO JKAP=1,IKAP-1                                  !!! over jkap
	IF(ABS(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN)).LE.1.D-05)THEN
	FF(IKAP,JKAP,L,ISORT,ISPIN)=1.D0
	FFP(IKAP,JKAP,L,ISORT,ISPIN)=0.D0
	FPF(IKAP,JKAP,L,ISORT,ISPIN)=0.D0
	FPFP(IKAP,JKAP,L,ISORT,ISPIN)=FPMN(L)
	ELSE
	E1=1.D0/(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN))
	WFF=SMT(ISORT)*AFIS(L,IKAP)*AFIS(L,JKAP)*
     &  (DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFFP=SMT(ISORT)*AFIS(L,IKAP)*AFIPS(L,JKAP)*
     &  (DNYP(L,JKAP)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFPF=SMT(ISORT)*AFIPS(L,IKAP)*AFIS(L,JKAP)*
     &  (DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNYP(L,IKAP))
	WFPFP=SMT(ISORT)*AFIPS(L,IKAP)*AFIPS(L,JKAP)*
     &  (DNYP(L,JKAP)-DNYP(L,IKAP))
	FF(IKAP,JKAP,L,ISORT,ISPIN)=E1*WFF
	FFP(IKAP,JKAP,L,ISORT,ISPIN)=E1*(WFFP+
     &  FF(IKAP,JKAP,L,ISORT,ISPIN))
	FPF(IKAP,JKAP,L,ISORT,ISPIN)=E1*(WFPF-
     &  FF(IKAP,JKAP,L,ISORT,ISPIN))
	FPFP(IKAP,JKAP,L,ISORT,ISPIN)=E1*(WFPFP+
     &  FPF(IKAP,JKAP,L,ISORT,ISPIN)-
     &  FFP(IKAP,JKAP,L,ISORT,ISPIN))
	ENDIF
	FF(JKAP,IKAP,L,ISORT,ISPIN)=FF(IKAP,JKAP,L,ISORT,ISPIN)
	FFP(JKAP,IKAP,L,ISORT,ISPIN)=FPF(IKAP,JKAP,L,ISORT,ISPIN)
	FPF(JKAP,IKAP,L,ISORT,ISPIN)=FFP(IKAP,JKAP,L,ISORT,ISPIN)
	FPFP(JKAP,IKAP,L,ISORT,ISPIN)=FPFP(IKAP,JKAP,L,ISORT,ISPIN)
        ENDDO                                                   !!! over jkap
        ENDDO                                                   !!! over l
        ENDDO                                                   !!! over ikap
        ENDDO                                                   !!! over isort
        ENDDO                                                   !!! over ispin
1010    FORMAT(1X,'DNY MISMATCH :','ENY=',G14.7,' DNY=',G14.7,' DHLOG=',
     &  G14.7,' IN',I2,1X,I2,1X,I2,1X,I2,1X,I2)
	END
