	SUBROUTINE SPLNRO
**************************************************************
*  Spline old density into new radial mesh.                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER TXTEL(NSORTMAX)*10
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),NSYMOLD(NPAT),LMOLD(NSYMMAX,NPAT)
     &   ,NRADOLD(NSORTMAX),NRAD(NSORTMAX)
	DIMENSION DERIN(0:NRADMAX,2),ORTH(2:3),H(NSORTMAX)
     &   ,ROLD(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX,2)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),DEROUT(0:NRADMAX,2)
     &   ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,ROTMPR(0:NRADMAX),ROTMPI(0:NRADMAX)
     &   ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from init
	COMMON /DENS/    RO,ROVALDS,ROCOR                   !!! from init 
	COMMON /PSRHO/   RHOPS                              !!! from init
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT                 !!! from radmsh
	COMMON /OLDMESH/ NSYMOLD,LMOLD,NRADOLD,ROLD         !!! from init
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                    !!! from init
	COMMON /SPIN/    NSPIN                              !!! from init
	COMMON /TXTEL/   TXTEL                              !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
C  FULL DENSITY AND PSEUDODENSITY
	DO 110 ISPIN=1,NSPIN                     !!! over spins
	DO 100 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	DO 10 I=0,NRAD(ISORT)
	IF(R(I,ISORT)-ROLD(NRADOLD(ISORT),ISORT).GT.1.D-09)GOTO20
  10    CONTINUE
	I=NRAD(ISORT)+1
  20    NR=I-1
	DO 90 ISYM=1,NSYMOLD(IATOM)
	DO 30 I=0,NRADOLD(ISORT)
	ROTMPR(I)=DREAL(RO(I,ISYM,IATOM,ISPIN))
	ROTMPI(I)=DIMAG(RO(I,ISYM,IATOM,ISPIN))
  30    CONTINUE
	CALL SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRADOLD(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMAX+1,-1)
	CALL SPLIN3(ROLD(0,ISORT),ROTMPI,DERIN,NRADOLD(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,2),DEROUT,NR+1,NRADMAX+1,-1)
	DO 40 I=0,NR
	RO(I,ISYM,IATOM,ISPIN)=DCMPLX(WORK1(I,1),WORK1(I,2))
  40    CONTINUE
	DO 50 I=NR+1,NRAD(ISORT)
	RO(I,ISYM,IATOM,ISPIN)=RO(NR,ISYM,IATOM,ISPIN)
  50    CONTINUE
  90    CONTINUE
 100    CONTINUE                                !!! over atoms
 110    CONTINUE                                !!! over spins
C  CORE DENSITY
	DO 270 ISPIN=1,NSPIN                     !!! over spins
	DO 260 ISORT=1,NSORT                     !!! over sort
	DO 210 I=0,NRAD(ISORT)
	IF(R(I,ISORT)-ROLD(NRADOLD(ISORT),ISORT).GT.1.D-09)GOTO220
 210    CONTINUE
	I=NRAD(ISORT)+1
 220    NR=I-1
	DO 230 I=0,NRADOLD(ISORT)
	ROTMPR(I)=ROCOR(I,ISORT,ISPIN)
 230    CONTINUE
	CALL SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRADOLD(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMAX+1,-1)
	DO 240 I=0,NR
	ROCOR(I,ISORT,ISPIN)=WORK1(I,1)
 240    CONTINUE
	DO 250 I=NR+1,NRAD(ISORT)
	ROCOR(I,ISORT,ISPIN)=ROCOR(NR,ISORT,ISPIN)
 250    CONTINUE
 260    CONTINUE                                !!! over sorts
 270    CONTINUE                                !!! over spins
	END

