	SUBROUTINE STRGNT(IPNT,IPAN)
*******************************************************
*   The calculation of the structure constants.       *
*   Last revision: 30.11.92, S.S.                     *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LDLMAX=(2*LMAXB+2)**2,NDTMAX=NPAT*NPAT
     &    ,LTLMAX=(LMAXT+1+LMAXB+1)**2)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IDELP(NPAT,NPAT),IS(NPAT),NKAP(NPANMAX),NPNT(NPANMAX)
	COMPLEX*16 SIGMA(LTLMAX),SIGMADOT(LDLMAX)
     &    ,SS(LIMLMT1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,SSDOT(LIMLMB1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,KAPPA,KAPPADOT,KAP,EK(NKAPMAX,NPANMAX)
     &    ,EKAP(NKAPMAX,NPANMAX)
	DIMENSION C(0:LMAXV+1,LMMAXV1,LMMAXV1),SMT(NSORTMAX)
     &    ,GGNT(0:LMAXV+1,0:LMAXV+1,0:LMAXV+1)
	LOGICAL FIRST,LOG
	COMMON /CONTROL/LIFT,LMTO,NLR,NINT                      !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /POTCOM/ SWZ,SMT                                 !!! from init
	COMMON /DENS/   SS,SSDOT                                !!! from strgnt
	COMMON /VECGEN/ LIMDT                                   !!! from vecgen
	COMMON /LM2STR/ IDELP                                   !!! from vecgen
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                       !!! from init
	COMMON /OUT1/   ICON                                    !!! from init
	COMMON /MESH/   NPNT                                    !!! from ttrmsh
	COMMON /LATPAR/ PAR                                     !!! from init
	COMMON /GAUNT/  C,GGNT                                  !!! from g_data
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(LMTO.GT.2)RETURN
C  CALCULATE SHIFT FOR THIS PANEL
	IF(ICON.NE.0)THEN ! sigma was calculated at the begining
	NSHIFT=1+NKAP(IPAN)*LIMDT*(IPNT-1)
	DO 10 JPAN=1,IPAN-1
	NSHIFT=NSHIFT+NPNT(JPAN)*NKAP(JPAN)*LIMDT
  10    CONTINUE
	ELSEIF(ICON.EQ.0)THEN ! no preliminary calculation of sigma
	NSHIFT=0
	ENDIF
C  RESTORE FULL S AND S_DOT -MATRICES FOR DIFF.ENERGIES
C  NOTE THAT SSQ IS DEFINED AS SQRT(S/2)*SS_LMTO*SQRT(S/2)
	DO 90 IKAP=1,NKAP(IPAN)                  !!! over diff.energies
	KAP=SQRT(EK(IKAP,IPAN))
	DO 80 JATOM=1,NATOM                      !!! over jatom
	JSORT=IS(JATOM)
	DO 70 IATOM=1,NATOM                      !!! over iatom
	ISORT=IS(IATOM)
	ITAU=IDELP(IATOM,JATOM)
	IREC=ITAU+LIMDT*(IKAP-1)+NSHIFT
	READ(8,REC=IREC)LIM2,LID2,(SIGMA(LM),LM=1,LIM2),
     &  (SIGMADOT(LM),LM=1,LID2)
	DO 60 L =0,ILSB(IS(JATOM))               !!! over l
	DO 50 L1=0,1+ILST(ISORT)                 !!! over l1
	LOG=.FALSE.
	IF(L1.LE.1+ILSB(ISORT))LOG=.TRUE.
	SOS=(SMT(ISORT)/SWZ)**(L1+0.5)*(SMT(JSORT)/SWZ)**(L+0.5)
	QSOSQ=SQRT(SMT(ISORT)/2.D0/PAR)*SOS*SQRT(SMT(JSORT)/2.D0/PAR)
	SQSOSQS=SWZ/PAR*QSOSQ*SWZ/PAR
	DO 40 M =-L,L                            !!! over m
	LM=L*(L+1)+M+1
	DO 30 M1=-L1,L1                          !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SS(L1M1,IATOM,LM,JATOM,IKAP)=(0.0,0.0)
	IF(LOG)SSDOT(L1M1,IATOM,LM,JATOM,IKAP)=(0.0,0.0)
	DO 20 L2=ABS(L-L1),L+L1,2      !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN          !!! over m2
	KAPPA=(1.D0,0.D0)              !!! energies are in units 1/a^2)
	IF(L+L1-L2.NE.0)KAPPA=(SWZ/PAR*KAP)**(L+L1-L2)
	KAPPADOT=(0.D0,0.D0)
	IF(L+L1-L2.NE.0.AND.ABS(EK(IKAP,IPAN)).NE.0.D0)THEN
	KAPPADOT=(L+L1-L2)*0.5D0*(SWZ/PAR*KAP)**(L+L1-L2-2)
	ELSEIF(L+L1-L2.EQ.2.AND.ABS(EK(IKAP,IPAN)).EQ.0.D0)THEN
	KAPPADOT=(1.D0,0.D0)
	ENDIF
	SS(L1M1,IATOM,LM,JATOM,IKAP)=SS(L1M1,IATOM,LM,JATOM,IKAP)+
     &  C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMA(L2M2)*QSOSQ*
     &  KAPPA
	IF(LOG)SSDOT(L1M1,IATOM,LM,JATOM,IKAP)=
     &  SSDOT(L1M1,IATOM,LM,JATOM,IKAP)+
     &  C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMADOT(L2M2)*
     &  SQSOSQS*KAPPA+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &  SIGMA(L2M2)*SQSOSQS*KAPPADOT
	ENDIF                          !!! over m2
  20    CONTINUE                       !!! over l2
  30    CONTINUE                       !!! over m1
  40    CONTINUE                       !!! over m
  50    CONTINUE                       !!! over l1
  60    CONTINUE                       !!! over l
  70    CONTINUE                       !!! over iatom
  80    CONTINUE                       !!! over jatom
  90    CONTINUE                       !!! over diff.energies
	IF(IPNT.EQ.NPNT(NPAN).AND.IPAN.EQ.NPAN)THEN
	IF(ICON.EQ.0)CLOSE(UNIT=8,STATUS='DELETE')
	IF(ICON.NE.0)CLOSE(UNIT=8)
	ENDIF
	END



	SUBROUTINE STRSUM(IPNT,IPAN)
*******************************************************
*   Calculate lattice sums if it was not done before. *
*   Last revision: 30.11.92, S.S.                     *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NDTMAX=NPAT*NPAT,LTLMAX=(LMAXT+1+LMAXB+1)**2
     &    ,LDLMAX=(2*LMAXB+2)**2)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IDELP(NPAT,NPAT),IS(NPAT),NKAP(NPANMAX),NPNT(NPANMAX)
     &    ,ILS2(NDTMAX),ILD2(NDTMAX),LIMLPL2(NDTMAX),LIMLDL2(NDTMAX)
     &    ,NDIV(3),NDIC(3)
	COMPLEX*16 SIGMA(LTLMAX,NDTMAX,NKAPMAX),EK(NKAPMAX,NPANMAX)
     &    ,SIGMADOT(LDLMAX,NDTMAX,NKAPMAX),EKAP(NKAPMAX,NPANMAX)
	DIMENSION SMT(NSORTMAX),PNT(3,KMAX,NPANMAX),SH(3,NPANMAX)
	CHARACTER*60 CONFILE,SCRFILE(100)
	LOGICAL FIRST,LOG
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                       !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /POTCOM/ SWZ,SMT                                 !!! from init
	COMMON /DENS/   SIGMA,SIGMADOT                          !!! from strgnt
	COMMON /VECGEN/ LIMDT                                   !!! from vecgen
	COMMON /LM2STR/ IDELP,NR2,ILS2,ILD2,LIMLPL2,LIMLDL2     !!! from vecgen
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP,EDGE                  !!! from init
	COMMON /INTTR/  NDIV,NDIC,SH                            !!! from init
	COMMON /OUT0/   SCRFILE                                 !!! from init
	COMMON /OUT1/   ICON                                    !!! from init
	COMMON /OUT2/   CONFILE                                 !!! from init
	COMMON /MESH/   NPNT,PNT                                !!! from ttrmsh
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(LMTO.GT.2)RETURN
C  FILE OPERATIONS
	IF(IPNT.EQ.1.AND.IPAN.EQ.1)THEN
	IF(ICON.EQ.0)OPEN(UNIT=8,FILE=SCRFILE(8),STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NR2)
	IF(ICON.NE.0)OPEN(UNIT=8,FILE=CONFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NR2)
	ENDIF
C  CALCULATE LATTICE SUMS IF IT WAS NOT DONE BEFORE
	IF(ICON.EQ.0)THEN
	IF(IPNT.EQ.1)LOG=.TRUE.
	IF(IPNT.NE.1)LOG=.FALSE. 
	XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
	YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
	ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
	IF(IPAN.EQ.1.OR.(DREAL(EKAP(1,IPAN)).GE.EDGE.AND.IPAN.NE.1))
     &  CALL DSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),LOG,
     &  LTLMAX,LDLMAX,NKAPMAX,SIGMA,SIGMADOT)
	IF(IPAN.NE.1.AND.DREAL(EKAP(1,IPAN)).LT.EDGE)
     &  CALL HSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),LOG,
     &  LTLMAX,LDLMAX,NKAPMAX,SIGMA,SIGMADOT)
	IREC=0
	DO 20 IKAP=1,NKAP(IPAN)
	DO 10 ITAU=1,LIMDT
	IREC=IREC+1
	WRITE(8,REC=IREC)LIMLPL2(ITAU),LIMLDL2(ITAU),
     &  (SIGMA(LM,ITAU,IKAP),LM=1,LIMLPL2(ITAU)),
     &  (SIGMADOT(LM,ITAU,IKAP),LM=1,LIMLDL2(ITAU))
  10    CONTINUE
  20    CONTINUE
	ENDIF
	END
