	SUBROUTINE TESTINP
****************************************************
*  Test input data for correct limits of arrays    *
****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),NKAP(NPANMAX),NBNDF(NPANMAX)
     &   ,NBNDT(NPANMAX),NBNDE(NPANMAX),LR(NSORTMAX)
	DIMENSION Z(NSORTMAX),ZCOR(NSORTMAX)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT
	COMMON /MULTRO/  Z,ZCOR                          !!! from init
	COMMON /SPIN/    NSPIN                           !!! from init
	COMMON /KAPPAR/  NPAN,NKAP                       !!! from init
	COMMON /RELATIV/ LR                              !!! from init
	COMMON /NBANDS/  NBNDF,NBNDE,NBNDT               !!! from init
	COMMON /TXTEL/   TXTEL                           !!! from init
	ZVAL=0.D0
	DO ISORT=1,NSORT
	IF(Z(ISORT).GT.21.AND.LR(ISORT).EQ.0)PRINT*,
     &  'No scalar relativism is switched on ',TXTEL(ISORT),
     &  '; Recommended when Z > 21' 
	IF(Z(ISORT).EQ.0.D0)Z(ISORT)=1.D-12
	IF(ZCOR(ISORT).EQ.0.D0)ZCOR(ISORT)=1.D-12
	ZVAL=ZVAL+(Z(ISORT)-ZCOR(ISORT))*NHSORT(ISORT)
	ENDDO
	DO IPAN=1,NPAN
	IF(NKAP(IPAN).GT.NKAPMAX)STOP'# OF KAPPA MISMATCH IN <TEST>'
	IF(NBNDT(IPAN).GT.NDIMMAX)STOP'NDIMMAX MISMATCH IN <TEST>'
	IF(NBNDF(IPAN).GT.NBNDT(IPAN))
     &  STOP'INPUT # OF FILLED BANDS > # OF TOTAL ONES'
	IF(IPAN.GT.1)ZVAL=ZVAL-2.D0*NBNDT(IPAN)
	ENDDO
	IF(2.D0*NBNDF(1).LT.ZVAL)PRINT*,'# OF FILLED BANDS IS TOO SMALL'
	IF(2.D0*NBNDF(1).LT.ZVAL)NBNDF(1)=ZVAL/2.D0+2
	END
