	SUBROUTINE SCELLS
**************************************************************
*  Find atomic cell enevelopes and store them. (Not used!)   *
*  After Dima.Yu.Savrasov (P.N.Lebedev PhysicaL Institute)   *
*  Last revision: 02.12.92.                                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTRMAX=NENVMAX)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NTR(NENVMAX),IREFAT(0:NVCMAX),LISTTR(3,NTRMAX,NENVMAX)
     &   ,NKAP(NPANMAX),NRAD(NSORTMAX),MDIV(3)
	DIMENSION WR(NPAT),RMT(NPAT),POLIST(3,NVCMAX),SASA(NSORTMAX)
     &   ,WS(NVCMAX),POLI(3,NVCMAX),RMT0(NPAT),Z(NSORTMAX),RBAS(3,3)
     &   ,TAU(3,NPAT),TAU0(3,NPAT),TAU00(3,NPAT),ZCOR(NSORTMAX)
     &   ,SMT(NSORTMAX),AD(3,3),RD(3,3)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10,SCRFILE(100)*60,BAS(0:3)*1
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS                                !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /BASIS0/ TAU0                                !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /OUT0/   SCRFILE                             !!! from init 
	COMMON /STORE1/ NP0,POLIST,NTR,LISTTR               !!! from polidet
	COMMON /SRFINP/ NDIV1,NDIV2                         !!! from init
	COMMON /ASASPH/ SASA                                !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN                         !!! from init
	COMMON /MULTRO/ Z,ZCOR                              !!! from init
	COMMON /RADMESH/NRAD                                !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from block
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/,BAS/'s','p','d','f'/
C  OPEN SCRATCH FILE
	OPEN(UNIT=9,FILE=SCRFILE(9),STATUS='NEW',FORM='UNFORMATTED')
C  FIND EXACT MT-SPHERES FOR THIS GEOMETRY
	DO 10 IATOM=1,NATOM
	WR(IATOM)=SASA(IS(IATOM))
  10    CONTINUE
	CALL NASOS(WR,RMT ,RBAS(1,1),RBAS(1,2),RBAS(1,3),TAU ,NATOM)
	CALL NASOS(WR,RMT0,RBAS(1,1),RBAS(1,2),RBAS(1,3),TAU0,NATOM)
C ***** DO GLOBALLY OVER ALL ATOMS IN CELL *****
	DO 50 IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
C SET UP ATOMIC CELL ENVELOPES AND STORE THEM
	IF(NDIV1.GT.0)THEN
	CALL POLISRCH(RMT0,IATOM,NDIV1,NPL,RMIN,RMAX,VOL,RV,
     &  POLI,WS,IREFAT)     
	IF(NPL.GT.NENVMAX)STOP'<SCELLS>: NENVMAX MUST BE INCREASED
     &  IN PARAM.DAT'
	ASAS=(3.D0/4.D0/PI*VOL)**(1.D0/3.D0)*PAR
	WRITE(9) (TAU(K,IATOM),K=1,3)
	WRITE(9) RMIN,RMAX,RMT(IATOM),RV,VOL
	WRITE(9) NP0,((POLIST(K,I),K=1,3),I=1,NP0)
	WRITE(9) NPL,(NTR(I),I=1,NPL)
	WRITE(9) (((LISTTR(K,I,J),K=1,3),I=1,NTR(J)),J=1,NPL)
	WRITE(9) ((POLI(K,I),K=1,3),I=1,NPL)
	WRITE(9) (WS(I),I=1,NPL),(IREFAT(I),I=0,NPL)
	ENDIF
C PRINT SPHERE RADII AND OTHER DATA
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(ISORT)
	NZ=Z(ISORT)
	NZCOR=ZCOR(ISORT)
	WRITE(IUN,1040)SMT(ISORT),SASA(ISORT)
	IF(NDIV1.GT.0)WRITE(IUN,1050)RMIN*PAR,ASAS
	WRITE(IUN,1060)RMT(IATOM)*PAR,NRAD(ISORT),NZ,NZCOR
	IF(NDIV1.GT.0)WRITE(IUN,1070)RMAX*PAR,NPL
  50    CONTINUE                              !!! over atoms
1010  FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1040  FORMAT(1X,'input mt-sphere is ',G14.7,' ; input as-sphere is ',
     &  G14.7)
1050  FORMAT(1X,'cell  mt-sphere is ',G14.7,' ; cell  as-sphere is ',
     &  G14.7)
1060  FORMAT(1X,'touch.mt-sphere is ',G14.7,' ; nrad=',I3,',znuc=',
     &  I3,',zcor=',I3)
1070  FORMAT(1X,'circums. sphere is ',G14.7,' ; npln=',I3)
	END
