	SUBROUTINE PRININI
**********************************************************
*  Print input/output data information.                  *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX),LR(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX),NDIC(3)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),NDIV(3)
	DIMENSION SMT(NSORTMAX),ORTH(2:3)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
        CHARACTER*60 INIFILE,SC0FILE,STRFILE,SCRFILE(100)
     &   ,HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
     &   ,CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &   ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &   ,OUTFILE
	CHARACTER TXTEL(NSORTMAX)*10,TEXT*64
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
	COMMON /CONTROL/MANAGE,LMTO,NLRK,NOVR,NPFR          !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
	COMMON /SCF1COM/NITER1                              !!! from readini
	COMMON /RELATIV/LR                                  !!! from readini
	COMMON /ORBS/   NORBS                               !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
	COMMON /EXCH/   IXC                                 !!! from readini
        COMMON /RWFCOM/ NRWF,LRWF,IRWF                      !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
	COMMON /MIXRHO1/ADMIX1,ADMIN,ADMAX                  !!! from readini
	COMMON /MIXMAG1/ADSPIN,ASMIN,ASMAX                  !!! from readini
	COMMON /MIXBROY/LBROY,IBROY,ADMIXB,ADMIXH           !!! from readini
	COMMON /EFERMI/ EF                                  !!! from readini
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                   !!! from readini
	COMMON /ACCU/   EPSTOT,EPSRHO,EPSMAG                !!! from readini
	COMMON /INTTR/  NDIV,NDIC                           !!! from readini
	COMMON /LATPAR/ PAR,ORTH                            !!! from readini
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from readini
C Additional inputs:
        COMMON /INP0/   INIFILE,SC0FILE,STRFILE             !!! from init
        COMMON /INP1/   ICHUB,ICHOP,ICOPT,ICENR,ICPNT       !!! from readini
        COMMON /INP2/   HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
C Outputs:
        COMMON /OUT0/   SCRFILE                             !!! from readini
        COMMON /OUT1/   ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND !!! from readini
     &                 ,ICPOT,ICFAT,ICDOS,ICSCF,ICOUT
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &                 ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &                 ,OUTFILE
	COMMON /TXTEL/  TXTEL                               !!! from readini
	COMMON /TEXT/   TEXT                                !!! from readini
	COMMON /UNIT/   IUN,IUT,IUR                         !!! from readini
C  PRINT HEAD
	IF(IUN.NE.IUT)CALL PHEAD(IUN)
        WRITE(IUN,1000)
1000    FORMAT(/' <<<--- INPUT INIFILE READ --->>>'/)
C  PRINT TITLE
        WRITE(IUN,1010)TEXT
        WRITE(IUN,1020)
1010    FORMAT(1X,A64)
1020    FORMAT(1X,'---------------------------------------------------')
C  PRINT CONTROL PARAMETERS
	WRITE(IUN,1030)
1030    FORMAT(1X,'<CONTROL PARAMETERS>    :')
	IF(MANAGE.EQ.1)WRITE(IUN,1035)
	IF(MANAGE.EQ.2)WRITE(IUN,1040)
	IF(MANAGE.EQ.3)WRITE(IUN,1050)
1035    FORMAT(1X,'lift  = 1',15X,'- Structure part only')
1040    FORMAT(1X,'lift  = 2',15X,'- Self-consistency is off')
1050    FORMAT(1X,'lift  = 3',15X,'- Self-consistency is on')
	IF(LMTO.EQ.1)WRITE(IUN,1060) 
	IF(LMTO.EQ.2)WRITE(IUN,1070) 
	IF(LMTO.EQ.3)WRITE(IUN,1080) 
1060    FORMAT(1X,'lmto  = 1',15X,'- Unscreened  LMTO is on')
1070    FORMAT(1X,'lmto  = 2',15X,'- Screened TB-LMTO is on')
1080    FORMAT(1X,'lmto  = 3',15X,'- Screened TB-LMTO is on')
C       IF(NLRK.EQ.1)WRITE(IUN,1080) 
C       IF(NLRK.EQ.0)WRITE(IUN,1090) 
C1080    FORMAT(1X,'nlrk  = 1',15X,'- Hamiltonian in R-space')
C1090    FORMAT(1X,'nlrk  = 2',15X,'- Hamiltonian in k-space')
	IF(LRWF.EQ.2)WRITE(IUN,1100) 
	IF(LRWF.EQ.1)WRITE(IUN,1110) 
	IF(LRWF.EQ.0)WRITE(IUN,1120) 
1100    FORMAT(1X,'lrwf  = 2',15X,'- Adjust Phi to Veff_spin')
1110    FORMAT(1X,'lrwf  = 1',15X,'- Adjust Phi to Veff only')
1120    FORMAT(1X,'lrwf  = 0',15X,'- Froze Phi after POTFILE')
	IF(NPFR.EQ.1)WRITE(IUN,1140) 
	IF(NPFR.EQ.0)WRITE(IUN,1150) 
1140    FORMAT(1X,'npfr  = 1',15X,'- Atomic forces   are on')
1150    FORMAT(1X,'npfr  = 0',15X,'- Atomic forces   are off')
C  EXCHANGE-CORRELATION
	WRITE(IUN,1199)
1199    FORMAT(1X,'<EXCHANGE-CORRELATION>  :')
	IF(IXC.EQ. 0)WRITE(IUN,1200)
	IF(IXC.EQ. 1)WRITE(IUN,1201)
	IF(IXC.EQ. 2)WRITE(IUN,1202)
	IF(IXC.EQ. 3)WRITE(IUN,1203)
	IF(IXC.EQ. 4)WRITE(IUN,1204)
	IF(IXC.EQ. 5)WRITE(IUN,1205)
	IF(IXC.EQ. 6)WRITE(IUN,1206)
	IF(IXC.EQ.10)WRITE(IUN,1210)
	IF(IXC.EQ.11)WRITE(IUN,1211)
	IF(IXC.EQ.12)WRITE(IUN,1212)
	IF(IXC.EQ.13)WRITE(IUN,1213)
	IF(IXC.EQ.14)WRITE(IUN,1214)
	IF(IXC.EQ.15)WRITE(IUN,1215)
	IF(IXC.EQ.16)WRITE(IUN,1216)
	IF(IXC.EQ.20)WRITE(IUN,1220)
	IF(IXC.EQ.21)WRITE(IUN,1221)
	IF(IXC.EQ.22)WRITE(IUN,1222)
	IF(IXC.EQ.23)WRITE(IUN,1223)
	IF(IXC.EQ.24)WRITE(IUN,1224)
	IF(IXC.EQ.25)WRITE(IUN,1225)
	IF(IXC.EQ.26)WRITE(IUN,1226)
1200    FORMAT(1X,'ixc   = 0',15X,'- Not included!')
1201    FORMAT(1X,'ixc   = 1',15X,'- Barth-Hedin, no GGA')
1202    FORMAT(1X,'ixc   = 2',15X,'- Gunnarson-Lundqvist, no GGA')
1203    FORMAT(1X,'ixc   = 3',15X,'- Janak-Williams-Morruzi, no GGA')
1204    FORMAT(1X,'ixc   = 4',15X,'- Vosko-Wilk-Nussair, no GGA')
1205    FORMAT(1X,'ixc   = 5',15X,'- Perdew-Wang, no GGA')
1206    FORMAT(1X,'ixc   = 6',15X,'- Gaspar-Kohn-Sham, no GGA')
1210    FORMAT(1X,'ixc   =10',15X,'- Not included!')
1211    FORMAT(1X,'ixc   =11',15X,'- Barth-Hedin + GGA91')
1212    FORMAT(1X,'ixc   =12',15X,'- Gunnarson-Lundqvist + GGA91')
1213    FORMAT(1X,'ixc   =13',15X,'- Janak-Williams-Morruzi + GGA91')
1214    FORMAT(1X,'ixc   =14',15X,'- Vosko-Wilk-Nussair + GGA91')
1215    FORMAT(1X,'ixc   =15',15X,'- Perdew-Wang + GGA91')
1216    FORMAT(1X,'ixc   =16',15X,'- Gaspar-Kohn-Sham + GGA91')
1220    FORMAT(1X,'ixc   =20',15X,'- Not included!')
1221    FORMAT(1X,'ixc   =21',15X,'- Barth-Hedin + GGA96')
1222    FORMAT(1X,'ixc   =22',15X,'- Gunnarson-Lundqvist + GGA96')
1223    FORMAT(1X,'ixc   =23',15X,'- Janak-Williams-Morruzi + GGA96')
1224    FORMAT(1X,'ixc   =24',15X,'- Vosko-Wilk-Nussair + GGA96')
1225    FORMAT(1X,'ixc   =25',15X,'- Perdew-Wang + GGA96')
1226    FORMAT(1X,'ixc   =26',15X,'- Gaspar-Kohn-Sham + GGA96')
C  ITERATIVE PROCEDURE LIMITS AND ACCURACY
	IF(MANAGE.EQ.3)THEN
	WRITE(IUN,1410)
1410    FORMAT(1X,'<CONVERGENCY DATA>      :')
	WRITE(IUN,1420)NITER1
1420    FORMAT(1X,'niter =',I3,14X,'- # of iterations')     
	WRITE(IUN,1430)EPSTOT
1430    FORMAT(1X,'epstot=',G14.7,3X,'- total energy   convergency')
	WRITE(IUN,1440)EPSRHO
1440    FORMAT(1X,'epsrho=',G14.7,3X,'- charge density convergency')
	IF(NSPIN.EQ.2)WRITE(IUN,1450)EPSMAG
1450    FORMAT(1X,'epsmag=',G14.7,3X,'- magnetization  convergency')
	IF(LBROY.LT.0)THEN
	WRITE(IUN,1455)LBROY
1455    FORMAT(1X,'lbroy =',G14.7,3X,'- Broyden mixing is off     ')
	WRITE(IUN,1460)ADMIX1
1460    FORMAT(1X,'admix =',G14.7,3X,'- initial mixing for density')
	WRITE(IUN,1470)ADMIN
1470    FORMAT(1X,'admin =',G14.7,3X,'- minimal mixing for density')
	WRITE(IUN,1480)ADMAX
1480    FORMAT(1X,'admax =',G14.7,3X,'- maximal mixing for density')
	IF(NSPIN.EQ.2)THEN
	WRITE(IUN,1490)ADSPIN
1490    FORMAT(1X,'asmix =',G14.7,3X,'- initial mixing for magnet.')
	WRITE(IUN,1500)ASMIN
1500    FORMAT(1X,'asmin =',G14.7,3X,'- minimal mixing for magnet.')
	WRITE(IUN,1510)ASMAX
1510    FORMAT(1X,'asmax =',G14.7,3X,'- maximal mixing for magnet.')
	ENDIF
	ELSEIF(LBROY.GE.0)THEN
	WRITE(IUN,1520)LBROY
1520    FORMAT(1X,'lbroy =',I3,14X,'- Broyden mixing is switched')
        WRITE(IUN,1530)IBROY
1530    FORMAT(1X,'ibroy =',I3,14X,'- after  n=ibroy  iterations')
	WRITE(IUN,1540)ADMIXB
1540    FORMAT(1X,'admixb=',G14.7,3X,'- initial guess for Jacobian')
	WRITE(IUN,1550)ADMIXH
1550    FORMAT(1X,'admixh=',G14.7,3X,'- mixing for high-l (>lbroy)')
	ENDIF
	ENDIF
C  ATOMIC DATA
	WRITE(IUN,1610)
1610    FORMAT(1X,'<ATOMIC DATA>           :')
	WRITE(IUN,1620)NATOM
	WRITE(IUN,1630)NSORT
1620    FORMAT(1X,'natom =',I3,14X,'- # of atoms in unit-cell')
1630    FORMAT(1X,'nsort =',I3,14X,'- # of atoms of different type')
	WRITE(IUN,1640)PAR
1640    FORMAT(1X,'par   =',G14.7,3X,'- lattice parameter in a.u.')
	IF(NSPIN.EQ.1)WRITE(IUN,1650)
	IF(NSPIN.EQ.2)WRITE(IUN,1651)
1650    FORMAT(1X,'nspin = 1',15X,'- no spin-polarization included')
1651    FORMAT(1X,'nspin = 2',15X,'- including spin-polarization')
	IF(NORBS.EQ.1)WRITE(IUN,1652)
	IF(NORBS.EQ.2)WRITE(IUN,1653)
1652    FORMAT(1X,'norbs = 1',15X,'- without spin-orbit coupling  ')
1653    FORMAT(1X,'norbs = 2',15X,'- with spin-orbit coupling   ')
	WRITE(IUN,1670)NKAP(1)
1670    FORMAT(1X,'nkap  =',I2,15X,'- # of kappas in valence panel')
	DO 1690 IKAP=1,NKAP(1)
	WRITE(IUN,1700)IKAP,REAL(EKAP(IKAP,1))
1690    CONTINUE
1700    FORMAT(1X,'Etail',I1,'=',G12.5,5X,'- Hankel tail energy')
C  OUTPUT PARAMETERS
	WRITE(IUN,2000)
2000    FORMAT(1X,'<OUTPUT DATA>           :')
	NB=INDEX(CONFILE,' ')
	IF(ICCON.EQ.0)WRITE(IUN,2010)
	IF(ICCON.EQ.1)WRITE(IUN,2020)CONFILE(:NB-1)
	IF(ICCON.EQ.2)WRITE(IUN,2030)CONFILE(:NB-1)
2010    FORMAT(1X,'icon  = 0',15X,'- no storage of str. const.')
2020    FORMAT(1X,'icon  = 1',15X,'- save str. const. in    ',A)
2030    FORMAT(1X,'icon  = 2',15X,'- read str. const. from  ',A)
	NB=INDEX(FTRFILE,' ')
	IF(ICFTR.EQ.0)WRITE(IUN,2040)
	IF(ICFTR.EQ.1)WRITE(IUN,2050)FTRFILE(:NB-1)
	IF(ICFTR.EQ.2)WRITE(IUN,2060)FTRFILE(:NB-1)
2040    FORMAT(1X,'iftr  = 0',15X,'- no storage fourier con.')
2050    FORMAT(1X,'iftr  = 1',15X,'- save fourier con.in    ',A)
2060    FORMAT(1X,'iftr  = 2',15X,'- read fourier con from  ',A)
	NB=INDEX(BNDFILE,' ')
	IF(    ICBND .EQ.0)WRITE(IUN,2070)
	IF(ABS(ICBND).EQ.1)WRITE(IUN,2080)BNDFILE(:NB-1)
	IF(    ICBND .EQ.2)WRITE(IUN,2090)BNDFILE(:NB-1)
2070    FORMAT(1X,'ibnd  = 0',15X,'- no storage of bands')
2080    FORMAT(1X,'ibnd  = 1',15X,'- save high-sym.bands in ',A)
2090    FORMAT(1X,'ibnd  = 2',15X,'- save tetra.bands    in ',A)
	NB=INDEX(DOSFILE,' ')
	IF(ICDOS.EQ.0)WRITE(IUN,2100)
	IF(ICDOS.EQ.1)WRITE(IUN,2110)DOSFILE(:NB-1)
2100    FORMAT(1X,'idos  = 0',15X,'- no d.o.s.calculation')
2110    FORMAT(1X,'idos  = 1',15X,'- save partial d.o.s. in ',A)
	NB=INDEX(POTFILE,' ')
	IF(ICPOT.EQ.0)WRITE(IUN,2120)
	IF(ICPOT.EQ.1)WRITE(IUN,2130)POTFILE(:NB-1)
2120    FORMAT(1X,'ipot  = 0',15X,'- no storage of full potential')
2130    FORMAT(1X,'ipot  = 1',15X,'- save full potential in ',A)
	NB=INDEX(SCFFILE,' ')
	IF(ICSCF.EQ.0)WRITE(IUN,2140)
	IF(ICSCF.NE.0)WRITE(IUN,2150)SCFFILE(:NB-1)
2140    FORMAT(1X,'iscf  = 0',15X,'- no storage of full density')
2150    FORMAT(1X,'iscf  = 1',15X,'- save full density   in ',A)
	NB=INDEX(OUTFILE,' ')
	IF(ICOUT.EQ.0)WRITE(IUN,2160)
	IF(ICOUT.EQ.1)WRITE(IUN,2170)OUTFILE(:NB-1)
	IF(ICOUT.GT.1)WRITE(IUN,2180)
2160    FORMAT(1X,'iout  = 0',15X,'- no output data file')
2170    FORMAT(1X,'iout  = 1',15X,'- save current output in ',A)
2180    FORMAT(1X,'iout  > 1',15X,'- print current output')
C  OTHER DATA FOR THE CODE
	WRITE(IUN,2200)
2200    FORMAT(1X,'<OTHER DATA>            :') 
	WRITE(IUN,2210)NBNDE(1)-1
	WRITE(IUN,2220)NBNDF(1)-NBNDE(1)+1
2210    FORMAT(1X,'nff   =',I3,14X,'- # of bands below    EF')
2220    FORMAT(1X,'nef   =',I3,14X,'- # of bands crossing EF')
	WRITE(IUN,2230)NDIV
	WRITE(IUN,2240)NDIC
2230    FORMAT(1X,'ndiv  =',I2,' ',I2,' ',I2,9X,
     &  '- tetr.mesh for valence  panel')
2240    FORMAT(1X,'ndic  =',I2,' ',I2,' ',I2,9X,
     &  '- tetr.mesh for semicore panels')
C  ADDITIONAL INPUT FILES
C  Hubbards
	WRITE(IUN,2300)
	IF(ICHUB.EQ.0)WRITE(IUN,2310)
	NB=INDEX(HUBFILE,' ')
	IF(NB.LT.2)NB=2
	IF(ICHUB.GT.0)WRITE(IUN,2311)HUBFILE(:NB-1)
C Hoppings
	IF(ICHOP.EQ.0)WRITE(IUN,2312)
	NB=INDEX(HOPFILE,' ')
	IF(NB.LT.2)NB=2
	IF(ICHOP.GT.0)WRITE(IUN,2313)HOPFILE(:NB-1)
C Optics
	IF(ICOPT.EQ.0)WRITE(IUN,2314)
	NB=INDEX(OPTFILE,' ')
	IF(NB.LT.2)NB=2
	IF(ICOPT.GT.0)WRITE(IUN,2315)OPTFILE(:NB-1)
C Bands for weights
	IF(ICENR.EQ.0)WRITE(IUN,2316)
	NB=INDEX(ENRFILE,' ')
	IF(NB.LT.2)NB=2
	IF(ICENR.GT.0)WRITE(IUN,2317)ENRFILE(:NB-1)
C List of perturbation vectors 
	IF(ICPNT.EQ.0)WRITE(IUN,2318)
	NB=INDEX(PNTFILE,' ')
	IF(NB.LT.2)NB=2
	IF(ICPNT.GT.0)WRITE(IUN,2319)PNTFILE(:NB-1)
2300    FORMAT(1X,'<ADDITIONAL INPUT FILES>:') 
2310	FORMAT(1X,'ichub  = 0',14X,'- with no Hubbard correction')
2311	FORMAT(1X,'ichub  > 0',14X,'- with Hubbard correction after ',A)
2312	FORMAT(1X,'ichop  = 0',14X,'- with no hopping matrix    ')
2313	FORMAT(1X,'ichop  > 0',14X,'- with TB-hopping matrix  after ',A)
2314	FORMAT(1X,'icopt  = 0',14X,'- with no optical properties')
2315	FORMAT(1X,'icopt  > 0',14X,'- with calculating optics after ',A)
2316	FORMAT(1X,'icenr  = 0',14X,'- with no dense grid for int')
2317	FORMAT(1X,'icenr  > 0',14X,'- with dense grid for int after ',A)
2318	FORMAT(1X,'icpnt  = 0',14X,'- with no perturbation q"s  ')
2319	FORMAT(1X,'icpnt  > 0',14X,'- with perturbation q"s   after ',A)
	END



        SUBROUTINE PRINSTR
***************************************************
*  Print STRFILE data                             *
***************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        CHARACTER*60 STRFILE,KOVFILE,CONFILE,FTRFILE,SYS*1,TXT*72
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NDIV(3),NDIC(3),M3(5)
        DIMENSION ORTH(2:3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),HSPNT(3,2,KMAX)
     &    ,SH(3,NPANMAX),AK(3,3,2),RK(3,3,2)
        CHARACTER PNTNOT(2,KMAX)*1,TEXT*64,TEXTS*64,TXTEL(NSORTMAX)*10
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM   !!! from readini
        COMMON /LATTICE/RBAS,GBAS,AK,RK                 !!! from readstr
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from readstr
        COMMON /BASIS/  TAU                             !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from readstr
        COMMON /OUT1/   ICCON,ICFTR,ICKOV               !!! from readstr
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE         !!! from readstr
        COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT         !!! from readstr
        COMMON /HSPNTS/ PNTNOT                          !!! from readstr
        COMMON /STRINP/ NVECMX,ALPHA                    !!! from readstr
        COMMON /SRFINP/ NDIV1,NDIV2                     !!! from readstr
        COMMON /TEXT/   TEXT,TEXTS                      !!! from readstr
        COMMON /TXTEL/  TXTEL                           !!! from readini
        COMMON /UNIT/   IUN                             !!! from readini
C  PRINT HEAD
        WRITE(IUN,1000)
1000    FORMAT(/'<<<--- INPUT STRFILE READ --->>>'/)
C  PRINT TITLE
        WRITE(IUN,1010)TEXTS
        WRITE(IUN,1020)
1010    FORMAT(1X,A64)
1020    FORMAT(1X,'---------------------------------------------------')
C  PRINT CONTROL PARAMETERS
        WRITE(IUN,1030)
1030    FORMAT(1X,'<CONTROL PARAMETERS>     :')
        WRITE(IUN,1031)NATOM
        WRITE(IUN,1032)ORTH(2)
        WRITE(IUN,1033)ORTH(3)
1031    FORMAT(1X,'natom =',I3,15X,  ' - # of atoms in unit-cell')
1032    FORMAT(1X,'b/a   =',G12.5,6X,' - orthorombicity  along b')
1033    FORMAT(1X,'c/a   =',G12.5,6X,' - orthorombicity  along c')
        IF(IBAS.EQ.1)WRITE(IUN,10301)IBAS
        IF(IBAS.NE.1)WRITE(IUN,10302)IBAS
        IF(IBZ .EQ.1)WRITE(IUN,10303)IBZ
        IF(IBZ .NE.1)WRITE(IUN,10304)IBZ
        IF(ICALC.EQ.1)WRITE(IUN,10305)ICALC
        IF(ICALC.NE.1)WRITE(IUN,10306)ICALC
        IF(ISTRAIN.EQ.1)WRITE(IUN,10307)ISTRAIN
        IF(ISTRAIN.NE.1)WRITE(IUN,10308)ISTRAIN
10301   FORMAT(1X,'ibas  =',I3,15X,  ' - basis in Cartesian sys.')
10302   FORMAT(1X,'ibas  =',I3,15X,  ' - basis in translations  ')
10303   FORMAT(1X,'ibz   =',I3,15X,  ' - automatic BZ - choice  ')
10304   FORMAT(1X,'ibz   =',I3,15X,  ' - read BZ from strfile   ')
10305   FORMAT(1X,'icalc =',I3,15X,  ' - using built-in calc.   ')
10306   FORMAT(1X,'icalc =',I3,15X,  ' - using numerical data   ')
10307   FORMAT(1X,'istrn =',I3,15X,  ' - distort cutoff sphere  ')
10308   FORMAT(1X,'istrn =',I3,15X,  ' - select plws in sphere  ')
        WRITE(IUN,1034)NDIV1
        WRITE(IUN,1035)NDIV2
1034    FORMAT(1X,'ndiv1 =',I3,15X,  ' - polyhedron   generation')
1035    FORMAT(1X,'ndiv2 =',I3,15X,  ' - polyhedron surface grid')
        WRITE(IUN,1036)NVECMX
        WRITE(IUN,1037)ALPHA
1036    FORMAT(1X,'nvec  =',I5,13X,  ' - vectors in Evald method')
1037    FORMAT(1X,'alpha =',G12.5,6X,' - splitting factor  there')
        WRITE(IUN,1040)
1040    FORMAT(1X,'<PRIMITIVE TRANSLATIONS> :')
        WRITE(IUN,1041)(RBAS(J,1),J=1,3)
        WRITE(IUN,1042)(RBAS(J,2),J=1,3)
        WRITE(IUN,1043)(RBAS(J,3),J=1,3)
1041    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! R1x,R1y,R1z')
1042    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! R2x,R2y,R2z')
1043    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! R3x,R3y,R3z')
        WRITE(IUN,1050)
1050    FORMAT(1X,'<BASIS ATOMS IN CELL>    :')
        DO 10 IATOM=1,NATOM
        WRITE(IUN,1051)(TAU(J,IATOM),J=1,3),TXTEL(IS(IATOM))
  10    CONTINUE
1051    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! ',A10)
        WRITE(IUN,1060)
1060    FORMAT(1X,'<STRAIN MATRIX>          :')
        WRITE(IUN,1061)(STRAIN(1,I,1),I=1,3)
        WRITE(IUN,1062)(STRAIN(2,I,1),I=1,3)
        WRITE(IUN,1063)(STRAIN(3,I,1),I=1,3)
1061    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Sxx,Sxy,Sxz')
1062    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Syx,Syy,Syz')
1063    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Szx,Szy,Szz')
        WRITE(IUN,1070)
1070    FORMAT(1X,'<INVERSE STRAIN MATRIX>  :')
        WRITE(IUN,1071)(STRAIN(1,I,2),I=1,3)
        WRITE(IUN,1072)(STRAIN(2,I,2),I=1,3)
        WRITE(IUN,1073)(STRAIN(3,I,2),I=1,3)
1071    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Rxx,Rxy,Rxz')
1072    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Ryx,Ryy,Ryz')
1073    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Rzx,Rzy,Rzz')
        WRITE(IUN,1080)
1080    FORMAT(1X,'<POINT GROUP DESCRIPTION>:')
	NB=INDEX(KOVFILE,' ')
        IF(ICKOV.EQ.1)WRITE(IUN,1081)
        IF(ICKOV.EQ.2)WRITE(IUN,1082)
        IF(ICKOV.EQ.3)WRITE(IUN,1083)KOVFILE(:NB-1)
1081    FORMAT(1X,'ikov  = C  - Cubic system')
1082    FORMAT(1X,'ikov  = H  - Hex.  system')
1083    FORMAT(1X,'ikov  = A  - Arbitray system specified in ',A)
        WRITE(IUN,1090)
1090    FORMAT(1X,'<RECIPROCAL LATTICE>     :')
        WRITE(IUN,1091)(GBAS(J,1),J=1,3)
        WRITE(IUN,1092)(GBAS(J,2),J=1,3)
        WRITE(IUN,1093)(GBAS(J,3),J=1,3)
1091    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! G1x,G1y,G1z')
1092    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! G2x,G2y,G2z')
1093    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! G3x,G3y,G3z')
        WRITE(IUN,1100)
1100    FORMAT(1X,'<BRILLOUIN ZONE>         :')
        WRITE(IUN,1101)(AK(J,1,1)*NDIV(1),J=1,3)
        WRITE(IUN,1102)(AK(J,2,1)*NDIV(2),J=1,3)
        WRITE(IUN,1103)(AK(J,3,1)*NDIV(3),J=1,3)
1101    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! K1x,K1y,K1z')
1102    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! K2x,K2y,K2z')
1103    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! K3x,K3y,K3z')
        IF(ABS(IBND).EQ.1)THEN
        WRITE(IUN,1110)
1110    FORMAT(1X,'<HIGH-SYMMETRY LINES>    :')
        WRITE(IUN,1111)NDIR
1111    FORMAT(1X,'ndir  =',I3,15X,' - # of directions in BZ')
        DO 20 IDIR=1,NDIR
        WRITE(IUN,1112)(PNTNOT(K,IDIR),K=1,2)
        WRITE(IUN,1113)(HSPNT(J,1,IDIR),J=1,3)
        WRITE(IUN,1114)(HSPNT(J,2,IDIR),J=1,3)
  20    CONTINUE
1112    FORMAT(1X,A1,'-',A1,10X,' - point notations')
1113    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! lx,ly,1z')
1114    FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! nx,ny,nz')
        ENDIF
        WRITE(IUN,1200)OMEGAC
1200    FORMAT(1X,'Cell Volume =',G14.7)
        END

