	SUBROUTINE RHOHUB
***********************************************************
*  Computes occupation numbers from the TOS-matrices.     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),NKAP(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSHJ(LIMLMB,LIMLMT,NPAT)
     &   ,ATOSJH(LIMLMT,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &   ,OHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,DHUB(LIMLMB2,NPAT,NSPINMAX),SUM
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /KAPPAR/ NPAN,NKAP                           !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ,TOSDOT  !!! from ttrint2
        COMMON /SUMPAR/ OHH,OJH,OHJ,OJJ                     !!! from ovrpar
        COMMON /HUBCOM/ DHUB                                !!! from ttrintm
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdat
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
	DO 4000 ISPIN=1,NSPIN                       !!! over spins
	DO 3000 IPAN=1,1                            !!! over panels
C  SET OCCUPATION NUMBERS TO ZERO
	DO IATOM=1,NATOM                            !!! over atoms
	ISORT=IS(IATOM) 
	DO L=0,ILSB(ISORT)                          !!! over l
        DO M1=-L,L                                  !!! over m1
        LM1=L*(L+1)+M1+1
        DO M=-L,L                                   !!! over m
        LM=L*(L+1)+M+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
        DHUB(IU,IATOM,ISPIN)=(0.D0,0.D0)
	ENDDO                                       !!! over m1
        ENDDO                                       !!! over m
        ENDDO                                       !!! over l
        ENDDO                                       !!! over atoms
	DO 2000 IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO 2000 IKAP=1,NKAP(IPAN)                   !!! over energies
	DO 1000 IATOM=1,NATOM                       !!! over atoms
	ISORT=IS(IATOM)
C  READ TOS-MATRICES
	NSHIFT1=0
	NSHIFT2=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
	ENDDO
        IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C  COMPUTE OCCUPATION NUMBERS
	DO L=0,ILSB(ISORT)                          !!! over l
        DO M1=-L,L                                  !!! over m1
        LM1=L*(L+1)+M1+1
        DO M=-L,L                                   !!! over m
        LM=L*(L+1)+M+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
	SUM=(0.D0,0.D0)
        IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
        SUM=SUM+ATOSHH(LM1,LM,IATOM)*OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
        SUM=SUM-ATOSHJ(LM1,LM,IATOM)*OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
        SUM=SUM-ATOSJH(LM1,LM,IATOM)*OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
        ENDIF
        SUM=SUM+ATOSJJ(LM1,LM,IATOM)*OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
	DHUB(IU,IATOM,ISPIN)=DHUB(IU,IATOM,ISPIN)+SUM
	ENDDO                                       !!! over m1
        ENDDO                                       !!! over m
        ENDDO                                       !!! over l
1000    CONTINUE                                    !!! over atoms
2000    CONTINUE                                    !!! over energies
3000    CONTINUE                                    !!! over panels
4000    CONTINUE                                    !!! over spins
        CLOSE(UNIT=21,STATUS='DELETE')
	END
