	SUBROUTINE WRITERO(ITER)
************************************************************
*     Store charge density at given iteration              *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NSYM(NPAT)
     &   ,ILSV(NSORTMAX),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,LNUM(36,NSORTMAX),NLEVC(NSORTMAX),NLEVT(NSORTMAX)
     &   ,NRAD(NSORTMAX),ICOR(NSORTMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
	DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX)
     &   ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ORTH(2:3)
     &   ,ZLEV(36,NSORTMAX),ELEV(36,NSORTMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,SMT(NSORTMAX),ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	CHARACTER*60 INIFILE,CONFILE,FTRFILE,KOVFILE,PTNFILE,WFFILE
     &   ,TMPFILE,POTFILE,SCFFILE,OUTFILE,BNDFILE,DOSFILE
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /CONTROL/ MAN,LMTO,NLR,NOVR
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from init
	COMMON /DENS/    RO,ROVALDS,ROCOR                   !!! from rofull
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                     !!! from symlm
	COMMON /POTCOM/  SWZ,SMT                            !!! from init
	COMMON /INPPAR/  TNY,ENY,DNY,NODES,MNY              !!! from init
	COMMON /KAPPAR/  NPAN,NKAP                          !!! from init
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                    !!! from init
	COMMON /COR1/    ICOR,NLEVC,NLEVT,ELEV,ZLEV,LNUM    !!! from rencor
	COMMON /RADMESH/ NRAD,H,R                           !!! from radmsh
	COMMON /OUT1/    ICON,IFTR,IKOV,IWF,ITMP,IBND,IPOT
     &                  ,IPTN,IDOS,ISCF,IOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,WFFILE,TMPFILE,BNDFILE
     &                  ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /SPIN/    NSPIN                              !!! from init
	COMMON /EFERMI/  EFERMI                             !!! from ttrint1
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
	IF(ITER.NE.0)THEN
	OPEN(3,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	CLOSE(UNIT=3,STATUS='DELETE')
	ENDIF
	OPEN(3,FILE=SCFFILE,STATUS='NEW',FORM='UNFORMATTED')
C  GENERAL INFORMATION
	WRITE(3)NATOM,NSORT,NSPIN,-1,(NRAD(ISORT),ISORT=1,
     &  NSORT),(ILSV(ISORT),ISORT=1,NSORT),(NSYM(IATOM),IATOM=1,NATOM)
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
C  RADIAL MESHES
	WRITE(3)(R(I,ISORT),I=0,NRAD(ISORT))
	WRITE(3)
C  SPHERICAL HARMONICS REPRESENTATION FOR THE DENSITY
	DO 10 LM=1,(ILSV(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	WRITE(3)LM
	WRITE(3)((RO(I,ISYM,IATOM,ISPIN),I=0,NRAD(ISORT)),
     &  ISPIN=1,NSPIN)
	ENDIF
  10    CONTINUE
C CORE INFORMATION
        WRITE(3)NLEVC(ISORT),NLEVT(ISORT)
        WRITE(3)(ZLEV(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
        WRITE(3)(ELEV(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
        WRITE(3)(LNUM(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
	WRITE(3)((ROCOR(I,ISORT,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	WRITE(3)
  20    CONTINUE
C  RESTART INFORMATION
	WRITE(3)NPAN,(NKAP(IPAN),IPAN=1,NPAN),
     &  (ILST(ISORT),ISORT=1,NSORT),(((((ENY(L,ISORT,IKAP,
     &  IPAN,ISPIN),L=0,ILST(ISORT)),ISORT=1,NSORT),IKAP=1,
     &  NKAP(IPAN)),IPAN=1,NPAN),ISPIN=1,NSPIN),
     &  (((((DNY(L,ISORT,IKAP,IPAN,ISPIN),L=0,ILST(ISORT)),
     &  ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),IPAN=1,NPAN),ISPIN=
     &  1,NSPIN),(((((TNY(L,ISORT,IKAP,IPAN,ISPIN),L=0,
     &  ILST(ISORT)),ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),IPAN=1,
     &  NPAN),ISPIN=1,NSPIN),((((NODES(L,ISORT,IKAP,IPAN),
     &  L=0,ILST(ISORT)),ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),
     &  IPAN=1,NPAN),((((MNY(L,ISORT,IKAP,IPAN),L=0,
     &  ILST(ISORT)),ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),IPAN=1,
     &  NPAN),EFERMI
	CLOSE(3)
	END



	SUBROUTINE READRO(ITER)
************************************************************
*     Store charge density at given iteration              *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NSYM(NPAT)
     &   ,ILSV(NSORTMAX),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,LNUM(36,NSORTMAX),NLEVC(NSORTMAX),NLEVT(NSORTMAX)
     &   ,NRAD(NSORTMAX),ICOR(NSORTMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
	DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX)
     &   ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ORTH(2:3)
     &   ,ZLEV(36,NSORTMAX),ELEV(36,NSORTMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,SMT(NSORTMAX),ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	CHARACTER*60 INIFILE,CONFILE,FTRFILE,KOVFILE,PTNFILE,WFFILE
     &   ,TMPFILE,POTFILE,SCFFILE,OUTFILE,BNDFILE,DOSFILE
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /CONTROL/ MAN,LMTO,NLR,NOVR
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from init
	COMMON /DENS/    RO,ROVALDS,ROCOR                   !!! from rofull
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                     !!! from symlm
	COMMON /POTCOM/  SWZ,SMT                            !!! from init
	COMMON /INPPAR/  TNY,ENY,DNY,NODES,MNY              !!! from init
	COMMON /KAPPAR/  NPAN,NKAP                          !!! from init
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                    !!! from init
	COMMON /COR1/    ICOR,NLEVC,NLEVT,ELEV,ZLEV,LNUM    !!! from rencor
	COMMON /RADMESH/ NRAD,H,R                           !!! from radmsh
	COMMON /OUT1/    ICON,IFTR,IKOV,IWF,ITMP,IBND,IPOT
     &                  ,IPTN,IDOS,ISCF,IOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,WFFILE,TMPFILE,BNDFILE
     &                  ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /SPIN/    NSPIN                              !!! from init
	COMMON /EFERMI/  EFERMI                             !!! from ttrint1
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
	OPEN(3,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
C  GENERAL INFORMATION
	READ(3)NATOM,NSORT,NSPIN,NLB,(NRAD(ISORT),ISORT=1,
     &  NSORT),(ILSV(ISORT),ISORT=1,NSORT),(NSYM(IATOM),IATOM=1,NATOM)
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
C  RADIAL MESHES
	READ(3)(R(I,ISORT),I=0,NRAD(ISORT))
	READ(3)
C  SPHERICAL HARMONICS REPRESENTATION FOR THE DENSITY
	DO 10 LM=1,(ILSV(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	READ(3)LM0
	READ(3)((RO(I,ISYM,IATOM,ISPIN),I=0,NRAD(ISORT)),
     &  ISPIN=1,NSPIN)
	ENDIF
  10    CONTINUE
C CORE INFORMATION
	READ(3)NLEVC(ISORT),NLEVT(ISORT)
	READ(3)(ZLEV(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
	READ(3)(ELEV(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
	READ(3)(LNUM(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
	READ(3)((ROCOR(I,ISORT,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	READ(3)
  20    CONTINUE
C  RESTART INFORMATION
	READ(3)NPAN,(NKAP(IPAN),IPAN=1,NPAN),
     &  (ILST(ISORT),ISORT=1,NSORT),(((((ENY(L,ISORT,IKAP,
     &  IPAN,ISPIN),L=0,ILST(ISORT)),ISORT=1,NSORT),IKAP=1,
     &  NKAP(IPAN)),IPAN=1,NPAN),ISPIN=1,NSPIN),
     &  (((((DNY(L,ISORT,IKAP,IPAN,ISPIN),L=0,ILST(ISORT)),
     &  ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),IPAN=1,NPAN),ISPIN=
     &  1,NSPIN),(((((TNY(L,ISORT,IKAP,IPAN,ISPIN),L=0,
     &  ILST(ISORT)),ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),IPAN=1,
     &  NPAN),ISPIN=1,NSPIN),((((NODES(L,ISORT,IKAP,IPAN),
     &  L=0,ILST(ISORT)),ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),
     &  IPAN=1,NPAN),((((MNY(L,ISORT,IKAP,IPAN),L=0,
     &  ILST(ISORT)),ISORT=1,NSORT),IKAP=1,NKAP(IPAN)),IPAN=1,
     &  NPAN),EFERMI
	CLOSE(3)
	END

	SUBROUTINE READSV(ITER)
************************************************************
*     Reads spherical potential from POTFILE               *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NSYM(NPAT)
     &    ,ILSV(NSORTMAX),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NRAD(NSORTMAX)
	DIMENSION VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),H(NSORTMAX)
     &    ,R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX),ORTH(2:3)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
	CHARACTER*60 INIFILE,CONFILE,FTRFILE,KOVFILE,PTNFILE,WFFILE
     &    ,TMPFILE,POTFILE,SCFFILE,OUTFILE,BNDFILE,DOSFILE
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /CONTROL/ MAN,LMTO,NLR,NOVR
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from init
	COMMON /POTCOM/  SWZ,SMT,VSPH,V                     !!! from init
	COMMON /RADMESH/ NRAD,H,R                           !!! from radmsh
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                    !!! from init
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                     !!! for rofull,etc
	COMMON /OUT1/    ICON,IFTR,IKOV,IWF,ITMP,IBND,IPOT,IPTN
     &                  ,IDOS,ISCF,IOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,WFFILE,TMPFILE,BNDFILE
     &                  ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /SPIN/    NSPIN                              !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
	IF(IPOT.NE.2)RETURN
	OPEN(3,FILE=POTFILE,STATUS='OLD',FORM='UNFORMATTED')
C  GENERAL INFORMATION
	READ(3)
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
C  RADIAL MESH
	READ(3)
C  SPHERICAL HARMONICS REPRESENTATION FOR THE POTENTIAL
	DO 10 LM=1,(ILSV(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	READ(3)LM0
	READ(3)
	ENDIF
  10    CONTINUE
	READ(3)((VSPH(I,ISORT,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
  20    CONTINUE
	CLOSE(3)
	END


	SUBROUTINE WRITEV(ITER)
************************************************************
*     Store potential at given iteration                   *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NSYM(NPAT)
     &    ,ILSV(NSORTMAX),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NRAD(NSORTMAX)
	DIMENSION VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),H(NSORTMAX)
     &    ,R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX),ORTH(2:3)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
	CHARACTER*60 INIFILE,CONFILE,FTRFILE,KOVFILE,PTNFILE,WFFILE
     &    ,TMPFILE,POTFILE,SCFFILE,OUTFILE,BNDFILE,DOSFILE
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /CONTROL/ MAN,LMTO,NLR,NOVR
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from init
	COMMON /POTCOM/  SWZ,SMT,VSPH,V                     !!! from init
	COMMON /RADMESH/ NRAD,H,R                           !!! from radmsh
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                    !!! from init
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                     !!! for rofull,etc
	COMMON /OUT1/    ICON,IFTR,IKOV,IWF,ITMP,IBND,IPOT,IPTN
     &                  ,IDOS,ISCF,IOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,WFFILE,TMPFILE,BNDFILE
     &                  ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /SPIN/    NSPIN                              !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
	IF(IPOT.EQ.0)RETURN
	IF(ITER.NE.1)THEN
	OPEN(3,FILE=POTFILE,STATUS='OLD',FORM='UNFORMATTED')
	CLOSE(UNIT=3,STATUS='DELETE')
	ENDIF
	OPEN(3,FILE=POTFILE,STATUS='NEW',FORM='UNFORMATTED')
C  GENERAL INFORMATION
	WRITE(3)NATOM,NSORT,NSPIN,-1,(NRAD(ISORT),ISORT=1,
     &  NSORT),(ILSV(ISORT),ISORT=1,NSORT),(NSYM(IATOM),IATOM=1,NATOM)
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
C  RADIAL MESH
	WRITE(3)(R(I,ISORT),I=0,NRAD(ISORT))
C  SPHERICAL HARMONICS REPRESENTATION FOR THE POTENTIAL
	DO 10 LM=1,(ILSV(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	WRITE(3)LM
	WRITE(3)((V(I,ISYM,IATOM,ISPIN),I=0,NRAD(ISORT)),
     &  ISPIN=1,NSPIN)
	ENDIF
  10    CONTINUE
	WRITE(3)((VSPH(I,ISORT,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
  20    CONTINUE
	CLOSE(3)
	END


